]> git.ipfire.org Git - thirdparty/git.git/blame - t/perf/perf-lib.sh
Merge git://ozlabs.org/~paulus/gitk
[thirdparty/git.git] / t / perf / perf-lib.sh
CommitLineData
c74c7203
JN
1# Performance testing framework. Each perf script starts much like
2# a normal test script, except it sources this library instead of
3# test-lib.sh. See t/perf/README for documentation.
342e9ef2
TR
4#
5# Copyright (c) 2011 Thomas Rast
6#
7# This program is free software: you can redistribute it and/or modify
8# it under the terms of the GNU General Public License as published by
9# the Free Software Foundation, either version 2 of the License, or
10# (at your option) any later version.
11#
12# This program is distributed in the hope that it will be useful,
13# but WITHOUT ANY WARRANTY; without even the implied warranty of
14# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
15# GNU General Public License for more details.
16#
17# You should have received a copy of the GNU General Public License
18# along with this program. If not, see http://www.gnu.org/licenses/ .
19
20# do the --tee work early; it otherwise confuses our careful
21# GIT_BUILD_DIR mangling
22case "$GIT_TEST_TEE_STARTED, $* " in
23done,*)
24 # do not redirect again
25 ;;
26*' --tee '*|*' --va'*)
27 mkdir -p test-results
28 BASE=test-results/$(basename "$0" .sh)
29 (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
30 echo $? > $BASE.exit) | tee $BASE.out
31 test "$(cat $BASE.exit)" = 0
32 exit
33 ;;
34esac
35
36TEST_DIRECTORY=$(pwd)/..
37TEST_OUTPUT_DIRECTORY=$(pwd)
38if test -z "$GIT_TEST_INSTALLED"; then
39 perf_results_prefix=
40else
41 perf_results_prefix=$(printf "%s" "${GIT_TEST_INSTALLED%/bin-wrappers}" | tr -c "[a-zA-Z0-9]" "[_*]")"."
42 # make the tested dir absolute
43 GIT_TEST_INSTALLED=$(cd "$GIT_TEST_INSTALLED" && pwd)
44fi
45
46TEST_NO_CREATE_REPO=t
ee1431bf 47TEST_NO_MALLOC_CHECK=t
342e9ef2
TR
48
49. ../test-lib.sh
50
561ae067
TR
51# Variables from test-lib that are normally internal to the tests; we
52# need to export them for test_perf subshells
53export TEST_DIRECTORY TRASH_DIRECTORY GIT_BUILD_DIR GIT_TEST_CMP
54
1a0962de
JK
55MODERN_GIT=$GIT_BUILD_DIR/bin-wrappers/git
56export MODERN_GIT
57
342e9ef2 58perf_results_dir=$TEST_OUTPUT_DIRECTORY/test-results
5d445f34 59test -n "$GIT_PERF_SUBSECTION" && perf_results_dir="$perf_results_dir/$GIT_PERF_SUBSECTION"
342e9ef2
TR
60mkdir -p "$perf_results_dir"
61rm -f "$perf_results_dir"/$(basename "$0" .sh).subtests
62
342e9ef2
TR
63die_if_build_dir_not_repo () {
64 if ! ( cd "$TEST_DIRECTORY/.." &&
65 git rev-parse --build-dir >/dev/null 2>&1 ); then
66 error "No $1 defined, and your build directory is not a repo"
67 fi
68}
69
70if test -z "$GIT_PERF_REPO"; then
71 die_if_build_dir_not_repo '$GIT_PERF_REPO'
72 GIT_PERF_REPO=$TEST_DIRECTORY/..
73fi
74if test -z "$GIT_PERF_LARGE_REPO"; then
75 die_if_build_dir_not_repo '$GIT_PERF_LARGE_REPO'
76 GIT_PERF_LARGE_REPO=$TEST_DIRECTORY/..
77fi
78
91de27c5
ÆAB
79test_perf_do_repo_symlink_config_ () {
80 test_have_prereq SYMLINKS || git config core.symlinks false
81}
82
342e9ef2
TR
83test_perf_create_repo_from () {
84 test "$#" = 2 ||
165293af 85 BUG "not 2 parameters to test-create-repo"
342e9ef2
TR
86 repo="$1"
87 source="$2"
83d4a409 88 source_git="$("$MODERN_GIT" -C "$source" rev-parse --git-dir)"
1a0962de 89 objects_dir="$("$MODERN_GIT" -C "$source" rev-parse --git-path objects)"
342e9ef2
TR
90 mkdir -p "$repo/.git"
91 (
e2522f2a 92 cd "$source" &&
7501b592
JS
93 { cp -Rl "$objects_dir" "$repo/.git/" 2>/dev/null ||
94 cp -R "$objects_dir" "$repo/.git/"; } &&
342e9ef2
TR
95 for stuff in "$source_git"/*; do
96 case "$stuff" in
7501b592 97 */objects|*/hooks|*/config|*/commondir)
342e9ef2
TR
98 ;;
99 *)
7501b592 100 cp -R "$stuff" "$repo/.git/" || exit 1
342e9ef2
TR
101 ;;
102 esac
e2522f2a
RS
103 done
104 ) &&
105 (
7501b592 106 cd "$repo" &&
91de27c5
ÆAB
107 "$MODERN_GIT" init -q &&
108 test_perf_do_repo_symlink_config_ &&
154ffeec
ÆAB
109 mv .git/hooks .git/hooks-disabled 2>/dev/null &&
110 if test -f .git/index.lock
111 then
112 # We may be copying a repo that can't run "git
113 # status" due to a locked index. Since we have
114 # a copy it's fine to remove the lock.
115 rm .git/index.lock
116 fi
342e9ef2
TR
117 ) || error "failed to copy repository '$source' to '$repo'"
118}
119
120# call at least one of these to establish an appropriately-sized repository
91de27c5
ÆAB
121test_perf_fresh_repo () {
122 repo="${1:-$TRASH_DIRECTORY}"
123 "$MODERN_GIT" init -q "$repo" &&
124 (
125 cd "$repo" &&
126 test_perf_do_repo_symlink_config_
127 )
128}
129
342e9ef2
TR
130test_perf_default_repo () {
131 test_perf_create_repo_from "${1:-$TRASH_DIRECTORY}" "$GIT_PERF_REPO"
132}
133test_perf_large_repo () {
134 if test "$GIT_PERF_LARGE_REPO" = "$GIT_BUILD_DIR"; then
135 echo "warning: \$GIT_PERF_LARGE_REPO is \$GIT_BUILD_DIR." >&2
136 echo "warning: This will work, but may not be a sufficiently large repo" >&2
137 echo "warning: for representative measurements." >&2
138 fi
139 test_perf_create_repo_from "${1:-$TRASH_DIRECTORY}" "$GIT_PERF_LARGE_REPO"
140}
141test_checkout_worktree () {
142 git checkout-index -u -a ||
143 error "git checkout-index failed"
144}
145
146# Performance tests should never fail. If they do, stop immediately
147immediate=t
148
e3efa94b
JS
149# Perf tests require GNU time
150case "$(uname -s)" in Darwin) GTIME="${GTIME:-gtime}";; esac
151GTIME="${GTIME:-/usr/bin/time}"
152
342e9ef2
TR
153test_run_perf_ () {
154 test_cleanup=:
155 test_export_="test_cleanup"
156 export test_cleanup test_export_
e3efa94b 157 "$GTIME" -f "%E %U %S" -o test_time.$i "$SHELL" -c '
1cbc3240 158. '"$TEST_DIRECTORY"/test-lib-functions.sh'
342e9ef2
TR
159test_export () {
160 [ $# != 0 ] || return 0
161 test_export_="$test_export_\\|$1"
162 shift
163 test_export "$@"
164}
165'"$1"'
166ret=$?
167set | sed -n "s'"/'/'\\\\''/g"';s/^\\($test_export_\\)/export '"'&'"'/p" >test_vars
168exit $ret' >&3 2>&4
169 eval_ret=$?
170
171 if test $eval_ret = 0 || test -n "$expecting_failure"
172 then
173 test_eval_ "$test_cleanup"
174 . ./test_vars || error "failed to load updated environment"
175 fi
176 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
177 echo ""
178 fi
179 return "$eval_ret"
180}
181
968e77a5
JK
182test_wrapper_ () {
183 test_wrapper_func_=$1; shift
62a23c9f 184 test_start_
342e9ef2
TR
185 test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
186 test "$#" = 2 ||
165293af 187 BUG "not 2 or 3 parameters to test-expect-success"
342e9ef2
TR
188 export test_prereq
189 if ! test_skip "$@"
190 then
191 base=$(basename "$0" .sh)
192 echo "$test_count" >>"$perf_results_dir"/$base.subtests
193 echo "$1" >"$perf_results_dir"/$base.$test_count.descr
968e77a5
JK
194 base="$perf_results_dir"/"$perf_results_prefix$(basename "$0" .sh)"."$test_count"
195 "$test_wrapper_func_" "$@"
196 fi
197
198 test_finish_
199}
200
201test_perf_ () {
202 if test -z "$verbose"; then
203 printf "%s" "perf $test_count - $1:"
204 else
205 echo "perf $test_count - $1:"
206 fi
207 for i in $(test_seq 1 $GIT_PERF_REPEAT_COUNT); do
208 say >&3 "running: $2"
209 if test_run_perf_ "$2"
210 then
211 if test -z "$verbose"; then
212 printf " %s" "$i"
342e9ef2 213 else
968e77a5 214 echo "* timing run $i/$GIT_PERF_REPEAT_COUNT:"
342e9ef2 215 fi
342e9ef2 216 else
968e77a5
JK
217 test -z "$verbose" && echo
218 test_failure_ "$@"
219 break
342e9ef2 220 fi
968e77a5
JK
221 done
222 if test -z "$verbose"; then
223 echo " ok"
224 else
225 test_ok_ "$1"
342e9ef2 226 fi
968e77a5
JK
227 "$TEST_DIRECTORY"/perf/min_time.perl test_time.* >"$base".times
228}
229
230test_perf () {
231 test_wrapper_ test_perf_ "$@"
342e9ef2
TR
232}
233
22bec79d
JK
234test_size_ () {
235 say >&3 "running: $2"
236 if test_eval_ "$2" 3>"$base".size; then
237 test_ok_ "$1"
238 else
239 test_failure_ "$@"
240 fi
241}
242
243test_size () {
244 test_wrapper_ test_size_ "$@"
245}
246
342e9ef2
TR
247# We extend test_done to print timings at the end (./run disables this
248# and does it after running everything)
249test_at_end_hook_ () {
250 if test -z "$GIT_PERF_AGGREGATING_LATER"; then
251 ( cd "$TEST_DIRECTORY"/perf && ./aggregate.perl $(basename "$0") )
252 fi
253}
254
255test_export () {
256 export "$@"
257}